diff -ruN ccp4srs-old/ccp4srs/ccp4srs_base.cpp ccp4srs/ccp4srs/ccp4srs_base.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_base.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_base.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -22,882 +22,892 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_base  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSBase - SRS base manager class
+//  **** Classes :  ccp4srs::Base - SRS base manager class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2013
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
 
-
 #include <string.h>
 #include <stdlib.h>
 
 #include "ccp4srs_base.h"
 #include "ccp4srs_defs.h"
-#include "mmdb/mmdb_tables.h"
-
-CCP4SRSBase::CCP4SRSBase()  {
-  init_base();
-}
+#include "mmdb2/mmdb_tables.h"
 
-CCP4SRSBase::~CCP4SRSBase()  {
-  freeMemory();
-}
+namespace ccp4srs  {
 
-void CCP4SRSBase::init_base()  {
+  Base::Base()  {
+    init_base();
+  }
 
-  index       = NULL;
-  srsDir      = NULL;
-  srsVersion  = CCP4SRS_file_version;
-  nEntries    = 0;
-  index_alloc = 0;
+  Base::~Base()  {
+    freeMemory();
+  }
 
-}
+  void Base::init_base()  {
 
-void CCP4SRSBase::freeMemory()  {
-int i;
+    index       = NULL;
+    srsDir      = NULL;
+    srsVersion  = CCP4SRS_file_version;
+    nEntries    = 0;
+    index_alloc = 0;
 
-  if (index)  {
-    for (i=0;i<index_alloc;i++)
-      if (index[i])  delete index[i];
-    delete[] index;
-    index = NULL;
   }
-  nEntries    = 0;
-  index_alloc = 0;
 
-  if (srsDir)  delete[] srsDir;
-  srsDir = NULL;
+  void Base::freeMemory()  {
+  int i;
 
-}
+    if (index)  {
+      for (i=0;i<index_alloc;i++)
+        if (index[i])  delete index[i];
+      delete[] index;
+      index = NULL;
+    }
+    nEntries    = 0;
+    index_alloc = 0;
+
+    if (srsDir)  delete[] srsDir;
+    srsDir = NULL;
 
-int CCP4SRSBase::loadIndex ( cpstr srsPath )  {
-CFile   f;
-CMemIO  memIO;
-pstr    S;
-int     i;
+  }
 
-  freeMemory();
+  int Base::loadIndex ( mmdb::cpstr srsPath )  {
+  mmdb::io::File f;
+  MemIO          memIO;
+  mmdb::pstr     S;
+  int            i;
 
-  if (srsPath)  {
-    CreateCopy ( srsDir,srsPath );
-    if (srsPath[0])  {
-      if (srsPath[strlen(srsPath)-1]!=_dir_sep_c)
-        CreateConcat ( srsDir,_dir_sep );
+    freeMemory();
+
+    if (srsPath)  {
+      mmdb::CreateCopy ( srsDir,srsPath );
+      if (srsPath[0])  {
+        if (srsPath[strlen(srsPath)-1]!=mmdb::io::_dir_sep_c)
+          mmdb::CreateConcat ( srsDir,mmdb::io::_dir_sep );
+      }
     }
-  }
 
-  S = NULL;
-  f.assign ( getPath(S,srsIndexFile),False,True );
-  if (S)  delete[] S;
+    S = NULL;
+    f.assign ( getPath(S,srsIndexFile),false,true );
+    if (S)  delete[] S;
 
-  if (f.reset(True))  {
+    if (f.reset(true))  {
 
-    f.ReadInt ( &srsVersion  );
-    f.ReadInt ( &index_alloc );
+      f.ReadInt ( &srsVersion  );
+      f.ReadInt ( &index_alloc );
 
-    if (index_alloc>0)  {
+      if (index_alloc>0)  {
+
+        index = new PIndex[index_alloc];
+        for (i=0;(i<index_alloc) && (!f.FileEnd()) && f.Success();i++)  {
+          memIO.reset();
+          index[nEntries] = new Index();
+          if (index[i]->read(f,srsVersion,&memIO)!=CCP4SRS_Ok)
+                delete index[nEntries];
+          else  nEntries++;
+        }
+
+        for (i=nEntries;i<index_alloc;i++)
+          index[i] = NULL;
 
-      index = new PCCP4SRSIndex[index_alloc];
-      for (i=0;(i<index_alloc) && (!f.FileEnd()) && f.Success();i++)  {
-        memIO.reset();
-        index[nEntries] = new CCP4SRSIndex();
-        if (index[i]->read(f,srsVersion,&memIO)!=CCP4SRS_Ok)
-              delete index[nEntries];
-        else  nEntries++;
       }
 
-      for (i=nEntries;i<index_alloc;i++)
-        index[i] = NULL;
+      f.shut();
 
-    }
+      if (nEntries==index_alloc)  return CCP4SRS_Ok;
+      return CCP4SRS_IndexCorrupt;
+
+    } else
+      return CCP4SRS_FileNotFound;
 
-    f.shut();
+  }
 
-    if (nEntries==index_alloc)  return CCP4SRS_Ok;
-    return CCP4SRS_IndexCorrupt;
+  PIndex Base::getIndex ( mmdb::cpstr entryID )  {
+  int n = getEntryNo ( entryID );
+    if ((n>=0) && (n<nEntries))  return index[n];
+    return NULL;
+  }
 
-  } else
-    return CCP4SRS_FileNotFound;
+  PIndex Base::getIndex ( int n )  {
+    if ((n>=0) && (n<nEntries))  return index[n];
+    return NULL;
+  }
 
-}
 
-PCCP4SRSIndex CCP4SRSBase::getIndex ( cpstr entryID )  {
-int n = getEntryNo ( entryID );
-  if ((n>=0) && (n<nEntries))  return index[n];
-  return NULL;
-}
+  int  Base::loadStructure ( mmdb::cpstr entryID )  {
+  UNUSED_ARGUMENT(entryID);
+    return CCP4SRS_Ok;
+  }
 
-PCCP4SRSIndex CCP4SRSBase::getIndex ( int n )  {
-  if ((n>=0) && (n<nEntries))  return index[n];
-  return NULL;
-}
+  int  Base::unloadStructure ( mmdb::cpstr entryID )  {
+  UNUSED_ARGUMENT(entryID);
+    return CCP4SRS_Ok;
+  }
 
 
-int  CCP4SRSBase::loadStructure ( cpstr entryID )  {
-UNUSED_ARGUMENT(entryID);
-  return CCP4SRS_Ok;
-}
+  mmdb::pstr Base::getPath ( mmdb::pstr & S, mmdb::cpstr FName )  {
+    if (srsDir)  mmdb::CreateCopCat ( S,srsDir,FName );
+           else  mmdb::CreateCopy   ( S,FName );
+    return S;
+  }
 
-int  CCP4SRSBase::unloadStructure ( cpstr entryID )  {
-UNUSED_ARGUMENT(entryID);
-  return CCP4SRS_Ok;
-}
 
+  int Base::getEntryNo ( mmdb::cpstr entryID )  {
+  mmdb::ResName id;
+  int           l1,l2,l,k;
 
-pstr CCP4SRSBase::getPath ( pstr & S, cpstr FName )  {
-  if (srsDir)  CreateCopCat ( S,srsDir,FName );
-         else  CreateCopy   ( S,FName );
-  return S;
-}
+    mmdb::strcpy_css ( id,entryID );
 
+    k = -1;
 
-int CCP4SRSBase::getEntryNo ( cpstr entryID )  {
-int     l1,l2,l,k;
-ResName id;
+    if (nEntries<=3)  {
+      for (l=0;(l<nEntries) && (k<0);l++)
+        if (!strcmp(index[l]->entryID,id))
+          k = l;
+      if (k>=0)  return k;
+      return CCP4SRS_EntryNotFound;
+    }
 
-  strcpy_css ( id,entryID );
+    l  = 0;
+    l1 = 0;
+    l2 = nEntries-1;
+    while (l1<l2-1)  {
+      l = (l1+l2)/2;
+      k = strcmp ( index[l]->entryID,id );
+      if (k<0)       l1 = l;
+      else if (k>0)  l2 = l;
+      else {
+        l1 = l;
+        l2 = l;
+      }
+    }
 
-  k = -1;
+    if (k==0)  return l;
+    else if (l==l1)  {
+      if (!strcmp(index[l2]->entryID,id))  return l2;
+    } else if (l==l2)  {
+      if (!strcmp(index[l1]->entryID,id))  return l1;
+    }
 
-  if (nEntries<=3)  {
-    for (l=0;(l<nEntries) && (k<0);l++)
-      if (!strcmp(index[l]->entryID,id))
-        k = l;
-    if (k>=0)  return k;
     return CCP4SRS_EntryNotFound;
+
   }
 
-  l  = 0;
-  l1 = 0;
-  l2 = nEntries-1;
-  while (l1<l2-1)  {
-    l = (l1+l2)/2;
-    k = strcmp ( index[l]->entryID,id );
-    if (k<0)       l1 = l;
-    else if (k>0)  l2 = l;
-    else {
-      l1 = l;
-      l2 = l;
-    }
-  }
-
-  if (k==0)  return l;
-  else if (l==l1)  {
-    if (!strcmp(index[l2]->entryID,id))  return l2;
-  } else if (l==l2)  {
-    if (!strcmp(index[l1]->entryID,id))  return l1;
-  }
-
-  return CCP4SRS_EntryNotFound;
-
-}
-
-PCFile CCP4SRSBase::getStructFile()  {
-PCFile structFile;
-pstr   S;
-  structFile = new CFile();
-  S = NULL;
-  structFile->assign ( getPath(S,srsStructFile),False,True );
-  if (S)  delete[] S;
-  if (!structFile->reset(True))  {
-    delete structFile;
-    structFile = NULL;
-  }
-  return structFile;
-}
-
-PCFile CCP4SRSBase::getGraphFile()  {
-PCFile graphFile;
-pstr   S;
-  graphFile = new CFile();
-  S = NULL;
-  graphFile->assign ( getPath(S,srsGraphFile),False,True );
-  if (S)  delete[] S;
-  if (!graphFile->reset(True))  {
-    delete graphFile;
-    graphFile = NULL;
-  }
-  return graphFile;
-}
-
-
-PCCP4SRSMonomer CCP4SRSBase::getMonomer ( cpstr entryID )  {
-//   getMonomer returns pointer to the monomer structure
-// identified by 3-letter entryID. If such structure is not
-// found, the function returns NULL.
-//   The function returns a pointer to a private copy of the
-// structure. Modifying it will not change data in the structural
-// database. The application is responsible for deallocating
-// the structure after use (simply use delete).
-//   See description of CCP4SRSMonomer for the explanation of
-// its fields.
-PCFile          structFile;
-PCCP4SRSMonomer srsMonomer;
-int             entryNo;
-
-  srsMonomer = NULL;
-  entryNo    = getEntryNo ( entryID );
-  if (entryNo!=CCP4SRS_EntryNotFound)  {
-    structFile = getStructFile();
-    if (structFile)  {
-      structFile->seek ( index[entryNo]->fStructPos );
-      srsMonomer = new CCP4SRSMonomer();
-      memIO.reset();
-      if (srsMonomer->read(*structFile,srsVersion,&memIO)!=CCP4SRS_Ok) {
-        delete srsMonomer;
-        srsMonomer = NULL;
-      }
-      structFile->shut ();
+  mmdb::io::PFile Base::getStructFile()  {
+  mmdb::io::PFile structFile;
+  mmdb::pstr      S;
+    structFile = new mmdb::io::File();
+    S = NULL;
+    structFile->assign ( getPath(S,srsStructFile),false,true );
+    if (S)  delete[] S;
+    if (!structFile->reset(true))  {
       delete structFile;
+      structFile = NULL;
     }
+    return structFile;
   }
 
-  return srsMonomer;
-
-}
+  mmdb::io::PFile Base::getGraphFile()  {
+  mmdb::io::PFile graphFile;
+  mmdb::pstr      S;
+    graphFile = new mmdb::io::File();
+    S = NULL;
+    graphFile->assign ( getPath(S,srsGraphFile),false,true );
+    if (S)  delete[] S;
+    if (!graphFile->reset(true))  {
+      delete graphFile;
+      graphFile = NULL;
+    }
+    return graphFile;
+  }
 
-PCCP4SRSMonomer CCP4SRSBase::getMonomer ( int entryNo,
-                                          PCFile structFile )  {
-PCFile          sFile;
-PCCP4SRSMonomer srsMonomer;
 
-  srsMonomer = NULL;
-  if ((0<=entryNo) && (entryNo<nEntries))  {
-    if (!structFile)  sFile = getStructFile();
-                else  sFile = structFile;
-    if (sFile)  {
-      sFile->seek ( index[entryNo]->fStructPos );
-      srsMonomer = new CCP4SRSMonomer();
-      memIO.reset();
-      if (srsMonomer->read(*sFile,srsVersion,&memIO)!=CCP4SRS_Ok) {
-        delete srsMonomer;
-        srsMonomer = NULL;
+  PMonomer Base::getMonomer ( mmdb::cpstr entryID )  {
+  //   getMonomer returns pointer to the monomer structure
+  // identified by 3-letter entryID. If such structure is not
+  // found, the function returns NULL.
+  //   The function returns a pointer to a private copy of the
+  // structure. Modifying it will not change data in the structural
+  // database. The application is responsible for deallocating
+  // the structure after use (simply use delete).
+  //   See description of CCP4SRSMonomer for the explanation of
+  // its fields.
+  mmdb::io::PFile structFile;
+  PMonomer        srsMonomer;
+  int             entryNo;
+
+    srsMonomer = NULL;
+    entryNo    = getEntryNo ( entryID );
+    if (entryNo!=CCP4SRS_EntryNotFound)  {
+      structFile = getStructFile();
+      if (structFile)  {
+        structFile->seek ( index[entryNo]->fStructPos );
+        srsMonomer = new Monomer();
+        memIO.reset();
+        if (srsMonomer->read(*structFile,srsVersion,&memIO)!=CCP4SRS_Ok) {
+          delete srsMonomer;
+          srsMonomer = NULL;
+        }
+        structFile->shut ();
+        delete structFile;
       }
-      if (!structFile)  delete sFile;
     }
+
+    return srsMonomer;
+
   }
 
-  return srsMonomer;
+  PMonomer Base::getMonomer ( int entryNo, mmdb::io::PFile structFile ) {
+  mmdb::io::PFile sFile;
+  PMonomer        srsMonomer;
+
+    srsMonomer = NULL;
+    if ((0<=entryNo) && (entryNo<nEntries))  {
+      if (!structFile)  sFile = getStructFile();
+                  else  sFile = structFile;
+      if (sFile)  {
+        sFile->seek ( index[entryNo]->fStructPos );
+        srsMonomer = new Monomer();
+        memIO.reset();
+        if (srsMonomer->read(*sFile,srsVersion,&memIO)!=CCP4SRS_Ok) {
+          delete srsMonomer;
+          srsMonomer = NULL;
+        }
+        if (!structFile)  delete sFile;
+      }
+    }
+
+    return srsMonomer;
 
-}
+  }
 
-PCCP4SRSMonomer CCP4SRSBase::getMonomer ( cpstr entryID,
-                                              PCFile structFile )  {
-//   Another form of getMonomer(..) uses an open structure
-// file, which allows to save on opening/closing file if
-// multiple access to SRS structures is required.
-int entryNo;
+  PMonomer Base::getMonomer ( mmdb::cpstr entryID,
+                              mmdb::io::PFile structFile )  {
+  //   Another form of getMonomer(..) uses an open structure
+  // file, which allows to save on opening/closing file if
+  // multiple access to SRS structures is required.
+  int entryNo;
 
-  entryNo    = getEntryNo ( entryID );
-  if (entryNo!=CCP4SRS_EntryNotFound)
-        return getMonomer ( entryNo,structFile );
-  else  return NULL;
+    entryNo    = getEntryNo ( entryID );
+    if (entryNo!=CCP4SRS_EntryNotFound)
+          return getMonomer ( entryNo,structFile );
+    else  return NULL;
 
-}
+  }
 
-int  CCP4SRSBase::getGraph ( PCFile graphFile, RPCGraph G )  {
-pstr buffer;
-int  buffer_length,rc,n;
+  int  Base::getGraph ( mmdb::io::PFile graphFile,
+                        mmdb::math::RPGraph G )  {
+  mmdb::pstr buffer;
+  int        buffer_length,rc,n;
 
-  rc = CCP4SRS_Ok;
+    rc = CCP4SRS_Ok;
 
-  memIO.reset();
-  if (memIO.read(*graphFile)==CMemIO::Ok)  {
-    memIO.get_buffer ( &buffer,&buffer_length );
-    if (buffer_length<=0)  {
+    memIO.reset();
+    if (memIO.read(*graphFile)==MemIO::Ok)  {
+      memIO.get_buffer ( &buffer,&buffer_length );
+      if (buffer_length<=0)  {
+        if (G)  delete G;
+        G = NULL;
+      } else  {
+        if (!G)  G = new mmdb::math::Graph();
+        n = 0;
+        G->mem_read ( buffer,n );
+        if (n!=buffer_length)  {
+          delete G;
+          G  = NULL;
+          rc = CCP4SRS_ReadErrors;
+        }
+      }
+    } else  {
+      rc = CCP4SRS_ReadErrors;
       if (G)  delete G;
       G = NULL;
-    } else  {
-      if (!G)  G = new CGraph();
-      n = 0;
-      G->mem_read ( buffer,n );
-      if (n!=buffer_length)  {
-        delete G;
-        G  = NULL;
-        rc = CCP4SRS_ReadErrors;
-      }
     }
-  } else  {
-    rc = CCP4SRS_ReadErrors;
-    if (G)  delete G;
-    G = NULL;
-  }
 
-  return rc;
+    return rc;
 
-}
+  }
 
-int  CCP4SRSBase::getGraph ( PCFile graphFile, int entryNo,
-                             RPCGraph G, int Hflag )  {
-//   getGraph(..) retrieves data for chemical structure number
-// entryNo (as in Index) from graph file graphFile, then allocates
-// and builds the corresponding graph, which is returned in G.
-//   If Hflag is set to 1, all hydrogens are removed from the graph.
-//   If Hflag is set to 2, element types of atoms, to which hydrogens
-// are bonded, are modified with flag HYDROGEN_BOND and moved to
-// the end.
-//   Returns 0 in case of success.
-int rc,htype;
+  int  Base::getGraph ( mmdb::io::PFile graphFile, int entryNo,
+                               mmdb::math::RPGraph G, int Hflag )  {
+  //   getGraph(..) retrieves data for chemical structure number
+  // entryNo (as in Index) from graph file graphFile, then allocates
+  // and builds the corresponding graph, which is returned in G.
+  //   If Hflag is set to 1, all hydrogens are removed from the graph.
+  //   If Hflag is set to 2, element types of atoms, to which hydrogens
+  // are bonded, are modified with flag HYDROGEN_BOND and moved to
+  // the end.
+  //   Returns 0 in case of success.
+  int rc,htype;
 
-  if ((entryNo<0) || (entryNo>=nEntries))
-    return CCP4SRS_EntryNotFound;
+    if ((entryNo<0) || (entryNo>=nEntries))
+      return CCP4SRS_EntryNotFound;
 
-  rc = CCP4SRS_Ok;
+    rc = CCP4SRS_Ok;
 
-/*
-  if (Index[structNo]->loadPos>=0)  {
+  /*
+    if (Index[structNo]->loadPos>=0)  {
 
-    if (!G)  G = new CGraph();
-    G->Copy ( ldGraph[Index[structNo]->loadPos] );
+      if (!G)  G = new CGraph();
+      G->Copy ( ldGraph[Index[structNo]->loadPos] );
 
-  } else  {
-*/
-  graphFile->seek ( index[entryNo]->fGraphPos );
-  graphFile->SetSuccess();
-  rc = getGraph ( graphFile,G );
-/*
-  if (memIO.read(*graphFile)==CMemIO::Ok)  {
-//  StreamRead ( *graphFile,G );
-    pstr buffer;
-    int  buffer_length,n;
-    memIO.get_buffer ( &buffer,&buffer_length );
-    if (buffer_length<=0)  {
-      if (G)  delete G;
-      G = NULL;
     } else  {
-      if (!G)  G = new CGraph();
-      n = 0;
-      G->mem_read ( buffer,n );
-      if (n!=buffer_length)  {
-        delete G;
-        G  = NULL;
-        rc = CCP4SRS_ReadErrors;
+  */
+    graphFile->seek ( index[entryNo]->fGraphPos );
+    graphFile->SetSuccess();
+    rc = getGraph ( graphFile,G );
+  /*
+    if (memIO.read(*graphFile)==CMemIO::Ok)  {
+  //  StreamRead ( *graphFile,G );
+      pstr buffer;
+      int  buffer_length,n;
+      memIO.get_buffer ( &buffer,&buffer_length );
+      if (buffer_length<=0)  {
+        if (G)  delete G;
+        G = NULL;
+      } else  {
+        if (!G)  G = new CGraph();
+        n = 0;
+        G->mem_read ( buffer,n );
+        if (n!=buffer_length)  {
+          delete G;
+          G  = NULL;
+          rc = CCP4SRS_ReadErrors;
+        }
       }
+    } else  {
+  //  if (!graphFile->Success())  {
+      rc = CCP4SRS_ReadErrors;
+      if (G)  delete G;
+      G = NULL;
     }
-  } else  {
-//  if (!graphFile->Success())  {
-    rc = CCP4SRS_ReadErrors;
-    if (G)  delete G;
-    G = NULL;
-  }
-*/
+  */
 
-/*
-  }
-*/
+  /*
+    }
+  */
 
-  if (G)  {
-    G->MakeVertexIDs();
-    if (Hflag>=1)  {
-      htype = getElementNo(pstr("H"));
-      if (Hflag==2)  G->HideType    ( htype );
-               else  G->ExcludeType ( htype );
+    if (G)  {
+      G->MakeVertexIDs();
+      if (Hflag>=1)  {
+        htype = mmdb::getElementNo(mmdb::pstr("H"));
+        if (Hflag==2)  G->HideType    ( htype );
+                 else  G->ExcludeType ( htype );
+      }
+      G->Build ( false );
     }
-    G->Build ( False );
-  }
 
-  return rc;
+    return rc;
 
-}
+  }
 
-int  CCP4SRSBase::getGraph ( PCFile graphFile, RPCGraph G,
-                             int Hflag )  {
-//   getGraph(..) retrieves data for chemical structure, which is
-// next in the graph file, then allocates and builds the corresponding
-// graph, which is returned in G.
-//   If Hflag is set to 1, all hydrogens are removed from the graph.
-//   If Hflag is set to 2, element types of atoms, to which hydrogens
-// are bonded, are modified with flag HYDROGEN_BOND and moved to
-// the end.
-//   Returns 0 in case of success.
-int rc,htype;
+  int  Base::getGraph ( mmdb::io::PFile graphFile,
+                               mmdb::math::RPGraph G,
+                               int Hflag )  {
+  //   getGraph(..) retrieves data for chemical structure, which is
+  // next in the graph file, then allocates and builds the corresponding
+  // graph, which is returned in G.
+  //   If Hflag is set to 1, all hydrogens are removed from the graph.
+  //   If Hflag is set to 2, element types of atoms, to which hydrogens
+  // are bonded, are modified with flag HYDROGEN_BOND and moved to
+  // the end.
+  //   Returns 0 in case of success.
+  int rc,htype;
 
-//  rc = 0;
+  //  rc = 0;
 
-  graphFile->SetSuccess();
-  rc = getGraph ( graphFile,G );
-//  StreamRead ( *graphFile,G );
+    graphFile->SetSuccess();
+    rc = getGraph ( graphFile,G );
+  //  StreamRead ( *graphFile,G );
 
-  if (!graphFile->Success())  {
-    rc = CCP4SRS_ReadErrors;
-    if (G)  delete G;
-    G = NULL;
-  }
+    if (!graphFile->Success())  {
+      rc = CCP4SRS_ReadErrors;
+      if (G)  delete G;
+      G = NULL;
+    }
 
-  if (G)  {
-    G->MakeVertexIDs();
-    if (Hflag>=1)  {
-      htype = getElementNo(pstr("H"));
-      if (Hflag==2)  G->HideType    ( htype );
-               else  G->ExcludeType ( htype );
+    if (G)  {
+      G->MakeVertexIDs();
+      if (Hflag>=1)  {
+        htype = mmdb::getElementNo(mmdb::pstr("H"));
+        if (Hflag==2)  G->HideType    ( htype );
+                 else  G->ExcludeType ( htype );
+      }
+      G->Build ( false );
     }
-    G->Build ( False );
-  }
 
-  return rc;
+    return rc;
 
-}
+  }
 
-int  CCP4SRSBase::getGraph ( int entryNo, RPCGraph G, int Hflag ) {
-PCFile graphFile;
-int    rc,htype;
+  int  Base::getGraph ( int entryNo, mmdb::math::RPGraph G,
+                               int Hflag ) {
+  mmdb::io::PFile graphFile;
+  int             rc,htype;
 
-  if ((0<=entryNo) && (entryNo<nEntries))  {
-    /*
-    if (Index[structNo]->loadPos>=0)  {
-      if (!G) G = new CGraph();
-      G->Copy ( ldGraph[Index[structNo]->loadPos] );
-    } else  {
-    */
-    graphFile = getGraphFile();
-    if (graphFile)  {
-      graphFile->seek ( index[entryNo]->fGraphPos );
-      rc = getGraph ( graphFile,G );
-//      StreamRead  ( *graphFile,G );
-      graphFile->shut ();
-      delete graphFile;
-      if (rc!=CCP4SRS_Ok)
-        return rc;
+    if ((0<=entryNo) && (entryNo<nEntries))  {
+      /*
+      if (Index[structNo]->loadPos>=0)  {
+        if (!G) G = new CGraph();
+        G->Copy ( ldGraph[Index[structNo]->loadPos] );
+      } else  {
+      */
+      graphFile = getGraphFile();
+      if (graphFile)  {
+        graphFile->seek ( index[entryNo]->fGraphPos );
+        rc = getGraph ( graphFile,G );
+  //      StreamRead  ( *graphFile,G );
+        graphFile->shut ();
+        delete graphFile;
+        if (rc!=CCP4SRS_Ok)
+          return rc;
+      } else  {
+        if (G)  delete G;
+        G = NULL;
+        return CCP4SRS_FileNotFound;
+      }
+      /*
+      }
+      */
     } else  {
       if (G)  delete G;
       G = NULL;
-      return CCP4SRS_FileNotFound;
-    }
-    /*
+      return CCP4SRS_EntryNotFound;
     }
-    */
-  } else  {
-    if (G)  delete G;
-    G = NULL;
-    return CCP4SRS_EntryNotFound;
-  }
 
-  if (G)  {
-    G->MakeVertexIDs();
-    if (Hflag>=1)  {
-      htype = getElementNo(pstr("H"));
-      if (Hflag==2)  G->HideType    ( htype );
-               else  G->ExcludeType ( htype );
+    if (G)  {
+      G->MakeVertexIDs();
+      if (Hflag>=1)  {
+        htype = mmdb::getElementNo(mmdb::pstr("H"));
+        if (Hflag==2)  G->HideType    ( htype );
+                 else  G->ExcludeType ( htype );
+      }
+      G->Build ( false );
     }
-    G->Build ( False );
-  }
 
-  return CCP4SRS_Ok;
+    return CCP4SRS_Ok;
 
-}
+  }
 
-int  CCP4SRSBase::getGraph ( cpstr entryID, RPCGraph G, int Hflag ) {
-PCFile graphFile;
-int    rc,entryNo,htype;
+  int  Base::getGraph ( mmdb::cpstr entryID, mmdb::math::RPGraph G, int Hflag ) {
+  mmdb::io::PFile graphFile;
+  int    rc,entryNo,htype;
 
-  entryNo = getEntryNo ( entryID );
+    entryNo = getEntryNo ( entryID );
 
-  if (entryNo!=CCP4SRS_EntryNotFound)  {
-    /*
-    if (Index[structNo]->loadPos>=0)  {
-      if (!G )  G = new CGraph();
-      G->Copy ( ldGraph[Index[structNo]->loadPos] );
-    } else  {
-    */
-    graphFile = getGraphFile();
-    if (graphFile)  {
-      graphFile->seek ( index[entryNo]->fGraphPos );
-      rc = getGraph ( graphFile,G );
-//      StreamRead      ( *graphFile,G );
-      graphFile->shut ();
-      delete graphFile;
-      if (rc!=CCP4SRS_Ok)
+    if (entryNo!=CCP4SRS_EntryNotFound)  {
+      /*
+      if (Index[structNo]->loadPos>=0)  {
+        if (!G )  G = new CGraph();
+        G->Copy ( ldGraph[Index[structNo]->loadPos] );
+      } else  {
+      */
+      graphFile = getGraphFile();
+      if (graphFile)  {
+        graphFile->seek ( index[entryNo]->fGraphPos );
+        rc = getGraph ( graphFile,G );
+  //      StreamRead      ( *graphFile,G );
+        graphFile->shut ();
+        delete graphFile;
+        if (rc!=CCP4SRS_Ok)
+          entryNo = CCP4SRS_FileNotFound;
+      } else  {
         entryNo = CCP4SRS_FileNotFound;
+        if (G)  delete G;
+        G = NULL;
+      }
+      /*
+      }
+      */
     } else  {
-      entryNo = CCP4SRS_FileNotFound;
       if (G)  delete G;
       G = NULL;
     }
+
+    if (G)  {
+      G->MakeVertexIDs();
+      if (Hflag>=1)  {
+        htype = mmdb::getElementNo(mmdb::pstr("H"));
+        if (Hflag==2)  G->HideType    ( htype );
+                 else  G->ExcludeType ( htype );
+      }
+      G->Build ( false );
+    }
+
+    return  entryNo;
+
     /*
+    if (structNo!=SBASE_StructNotFound)  {
+      return  GetGraph ( structNo,G,Hflag );
+    } else  {
+      if (G)  delete G;
+      G = NULL;
+      return  structNo;
     }
     */
-  } else  {
-    if (G)  delete G;
-    G = NULL;
-  }
 
-  if (G)  {
-    G->MakeVertexIDs();
-    if (Hflag>=1)  {
-      htype = getElementNo(pstr("H"));
-      if (Hflag==2)  G->HideType    ( htype );
-               else  G->ExcludeType ( htype );
-    }
-    G->Build ( False );
   }
 
-  return  entryNo;
 
-  /*
-  if (structNo!=SBASE_StructNotFound)  {
-    return  GetGraph ( structNo,G,Hflag );
-  } else  {
-    if (G)  delete G;
-    G = NULL;
-    return  structNo;
+  int Base::getNofAtoms ( mmdb::cpstr entryID )  {
+  // Returns the number of atoms in the references monomer. 'entryID' is
+  // the 3-letter cif code. Non-negative return delivers the number of
+  // atoms, otherwise CCP4SRS_EntryNotFound indicates that the requested
+  // structure was not found in the database.
+  int entryNo;
+    entryNo = getEntryNo ( entryID );
+    if (entryNo>=0)
+      return index[entryNo]->nAtoms;
+    return entryNo;
+  }
+
+  int Base::getNofAtoms ( int entryNo )  {
+  // Returns the number of atoms in the references monomer. 'entryNo' is
+  // the entry number (0...n_entries()-1). Non-negative return delivers
+  // the number of atoms, otherwise CCP4SRS_EntryNotFound indicates that
+  // the requested structure was not found in the database
+    if ((0<=entryNo) && (entryNo<nEntries))
+      return index[entryNo]->nAtoms;
+    return CCP4SRS_EntryNotFound;
   }
-  */
 
-}
 
+  int Base::getNofAtoms ( int entryNo,  int & nNonHAtoms,
+                                 int & nHAtoms )  {
+  mmdb::pstr  p1,p2;
+
+    nNonHAtoms = 0;
+    nHAtoms    = 0;
+
+    if ((entryNo<0) || (entryNo>=nEntries))
+      return CCP4SRS_EntryNotFound;
+
+    nNonHAtoms = index[entryNo]->nAtoms;
+    nHAtoms    = 0;
+    if (index[entryNo]->Comp1)  {
+      p1 = strstr ( index[entryNo]->Comp1,"H(" );
+      if (p1)  {
+        p1 += 2;
+        p2  = p1;
+        while ((*p2) && (*p2!=')'))  p2++;
+        if (*p2==')')  {
+          *p2 = char(0);
+          nHAtoms = mmdb::mround(strtod(p1,NULL));
+          *p2 = ')';
+        }
+      }
+    }
 
-int CCP4SRSBase::getNofAtoms ( cpstr entryID )  {
-// Returns the number of atoms in the references monomer. 'entryID' is
-// the 3-letter cif code. Non-negative return delivers the number of
-// atoms, otherwise CCP4SRS_EntryNotFound indicates that the requested
-// structure was not found in the database.
-int entryNo;
-  entryNo = getEntryNo ( entryID );
-  if (entryNo>=0)
-    return index[entryNo]->nAtoms;
-  return entryNo;
-}
-
-int CCP4SRSBase::getNofAtoms ( int entryNo )  {
-// Returns the number of atoms in the references monomer. 'entryNo' is
-// the entry number (0...n_entries()-1). Non-negative return delivers
-// the number of atoms, otherwise CCP4SRS_EntryNotFound indicates that
-// the requested structure was not found in the database
-  if ((0<=entryNo) && (entryNo<nEntries))
-    return index[entryNo]->nAtoms;
-  return CCP4SRS_EntryNotFound;
-}
-
-
-int CCP4SRSBase::getNofAtoms ( int entryNo,  int & nNonHAtoms,
-                               int & nHAtoms )  {
-pstr  p1,p2;
+    nNonHAtoms -= nHAtoms;
 
-  nNonHAtoms = 0;
-  nHAtoms    = 0;
+    return CCP4SRS_Ok;
 
-  if ((entryNo<0) || (entryNo>=nEntries))
-    return CCP4SRS_EntryNotFound;
+  }
 
-  nNonHAtoms = index[entryNo]->nAtoms;
-  nHAtoms    = 0;
-  if (index[entryNo]->Comp1)  {
-    p1 = strstr ( index[entryNo]->Comp1,"H(" );
-    if (p1)  {
-      p1 += 2;
-      p2  = p1;
-      while ((*p2) && (*p2!=')'))  p2++;
-      if (*p2==')')  {
-        *p2 = char(0);
-        nHAtoms = mround(strtod(p1,NULL));
-        *p2 = ')';
-      }
-    }
+
+  int Base::getAtNames ( int  entryNo, mmdb::PAtomName AtName,
+                                int & nAtoms, int & nH )  {
+  mmdb::io::PFile structFile;
+  int             rc;
+    nAtoms = 0;
+    nH     = 0;
+    if ((entryNo<0) || (entryNo>=nEntries))
+      return CCP4SRS_EntryNotFound;
+    structFile = getStructFile();
+    if (structFile)  {
+      rc = getAtNames ( structFile,entryNo,AtName,nAtoms,nH );
+      structFile->shut();
+      delete structFile;
+    } else
+      return CCP4SRS_FileNotFound;
+    return rc;
   }
 
-  nNonHAtoms -= nHAtoms;
 
-  return CCP4SRS_Ok;
+  int Base::getAtNames ( mmdb::io::PFile structFile, int entryNo,
+                         mmdb::PAtomName AtName,
+                         int & nAtoms, int & nH )  {
+  PMonomer       monomer;
+  PAtom          atom;
+  mmdb::AtomName aname;
+  int            i,j;
+  mmdb::pstr     p1,p2;
+  bool           removeHydrogens;
+
+    if ((entryNo<0) || (entryNo>=nEntries))
+      return CCP4SRS_EntryNotFound;
+
+    removeHydrogens = (nH==-1);
+
+    monomer = getMonomer ( entryNo,structFile );
+    if (!monomer)
+      return CCP4SRS_ReadErrors;
+
+    nAtoms = index[entryNo]->nAtoms;
+    nH     = 0;
+    if (index[entryNo]->Comp1)  {
+      p1 = strstr ( index[entryNo]->Comp1,"H(" );
+      if (p1)  {
+        p1 += 2;
+        p2  = p1;
+        while ((*p2) && (*p2!=')'))  p2++;
+        if (*p2==')')  {
+          *p2 = char(0);
+          nH  = mmdb::mround(strtod(p1,NULL));
+          *p2 = ')';
+        }
+      }
+    }
 
-}
+    if (removeHydrogens)  {
+      j = 0;
+      for (i=0;i<nAtoms;i++)  {
+        atom = monomer->atom(i);
+        if (atom)  {
+          if ((atom->element()[0]!='H') || (atom->element()[1]))
+            strcpy ( AtName[j++],atom->name_pdb(aname) );
+        }
+      }
+    } else  {
+      for (i=0;i<nAtoms;i++)  {
+        atom = monomer->atom(i);
+        if (atom)
+          strcpy ( AtName[i],atom->name_pdb(aname) );
+      }
+    }
 
+    delete monomer;
 
-int CCP4SRSBase::getAtNames ( int  entryNo, PAtomName AtName,
-                              int & nAtoms, int & nH )  {
-int    rc;
-PCFile structFile;
-  nAtoms = 0;
-  nH     = 0;
-  if ((entryNo<0) || (entryNo>=nEntries))
-    return CCP4SRS_EntryNotFound;
-  structFile = getStructFile();
-  if (structFile)  {
-    rc = getAtNames ( structFile,entryNo,AtName,nAtoms,nH );
-    structFile->shut();
-    delete structFile;
-  } else
-    return CCP4SRS_FileNotFound;
-  return rc;
-}
-
-
-int CCP4SRSBase::getAtNames ( PCFile structFile, int entryNo,
-                              PAtomName AtName,
-                              int & nAtoms, int & nH )  {
-PCCP4SRSMonomer monomer;
-PCCP4SRSAtom    atom;
-AtomName        aname;
-int             i,j;
-pstr            p1,p2;
-Boolean         removeHydrogens;
+    return CCP4SRS_Ok;
 
-  if ((entryNo<0) || (entryNo>=nEntries))
-    return CCP4SRS_EntryNotFound;
+  }
 
-  removeHydrogens = (nH==-1);
 
-  monomer = getMonomer ( entryNo,structFile );
-  if (!monomer)
-    return CCP4SRS_ReadErrors;
-
-  nAtoms = index[entryNo]->nAtoms;
-  nH     = 0;
-  if (index[entryNo]->Comp1)  {
-    p1 = strstr ( index[entryNo]->Comp1,"H(" );
-    if (p1)  {
-      p1 += 2;
-      p2  = p1;
-      while ((*p2) && (*p2!=')'))  p2++;
-      if (*p2==')')  {
-        *p2 = char(0);
-        nH  = mround(strtod(p1,NULL));
-        *p2 = ')';
-      }
-    }
+  int _makeChirInd ( char chirality )  {
+    if (chirality=='S')  return -1;
+    if (chirality=='R')  return +1;
+    return 0;
   }
 
-  if (removeHydrogens)  {
-    j = 0;
-    for (i=0;i<nAtoms;i++)  {
-      atom = monomer->atom(i);
-      if (atom)  {
-        if ((atom->element()[0]!='H') || (atom->element()[1]))
-          strcpy ( AtName[j++],atom->name_pdb(aname) );
-      }
-    }
-  } else  {
-    for (i=0;i<nAtoms;i++)  {
-      atom = monomer->atom(i);
-      if (atom)
-        strcpy ( AtName[i],atom->name_pdb(aname) );
+  int _findName ( mmdb::PAtomName Nams, mmdb::cpstr N, int len )  {
+  mmdb::AtomName Nam;
+  int            i;
+    i = 0;
+    while (i<len)  {
+      strcpy ( Nam,Nams[i] );
+      if (!strcmp(N,Nam))  break;
+      i++;
     }
+    if (i>=len)  i = -1;
+    return i;
   }
 
-  delete monomer;
+  int Base::getAtoms ( mmdb::cpstr     entryID,
+                              int           & nNonHAtoms,
+                              mmdb::PAtomName NonHAtName,
+                              int           & nHAtoms,
+                              mmdb::PAtomName HAtName,
+                              mmdb::ivector   Hconnect,
+                              mmdb::ivector   Elem,
+                              mmdb::ivector   Chiral )  {
+  PMonomer       monomer;
+  PAtom          atom,atom2;
+  PBond          bond;
+  mmdb::AtomName aname;
+  int            i,j,entryNo,rc;
 
-  return CCP4SRS_Ok;
+    nNonHAtoms = 0;
+    nHAtoms    = 0;
 
-}
-
-
-int _makeChirInd ( char chirality )  {
-  if (chirality=='S')  return -1;
-  if (chirality=='R')  return +1;
-  return 0;
-}
-
-int _findName ( PAtomName Nams, cpstr N, int len )  {
-int      i;
-AtomName Nam;
-  i = 0;
-  while (i<len)  {
-    strcpy ( Nam,Nams[i] );
-    if (!strcmp(N,Nam))  break;
-    i++;
-  }
-  if (i>=len)  i = -1;
-  return i;
-}
-
-int CCP4SRSBase::getAtoms ( cpstr entryID,
-                            int & nNonHAtoms, PAtomName NonHAtName,
-                            int & nHAtoms,    PAtomName HAtName,
-                            ivector Hconnect, ivector Elem,
-                            ivector Chiral )  {
-PCCP4SRSMonomer monomer;
-PCCP4SRSAtom    atom,atom2;
-PCCP4SRSBond    bond;
-AtomName        aname;
-int             i,j,entryNo,rc;
-
-  nNonHAtoms = 0;
-  nHAtoms    = 0;
-
-  entryNo = getEntryNo ( entryID );
-  if (entryNo<0)  return CCP4SRS_EntryNotFound;
-
-  monomer = getMonomer ( entryNo,NULL );
-  if (!monomer)
-    return CCP4SRS_ReadErrors;
-
-  rc = CCP4SRS_Ok;
-
-  for (i=0;i<index[entryNo]->nAtoms;i++)  {
-    atom = monomer->atom(i);
-    if (atom)  {
-      Elem[i] = getElementNo ( atom->element() );
-      if ((atom->element()[0]=='H') && (!atom->element()[1]))  {
-        strcpy ( HAtName[nHAtoms],atom->name_pdb(aname) );
-        nHAtoms++;
-      } else  {
-        strcpy ( NonHAtName[nNonHAtoms],atom->name_pdb(aname) );
-        nNonHAtoms++;
+    entryNo = getEntryNo ( entryID );
+    if (entryNo<0)  return CCP4SRS_EntryNotFound;
+
+    monomer = getMonomer ( entryNo,NULL );
+    if (!monomer)
+      return CCP4SRS_ReadErrors;
+
+    rc = CCP4SRS_Ok;
+
+    for (i=0;i<index[entryNo]->nAtoms;i++)  {
+      atom = monomer->atom(i);
+      if (atom)  {
+        Elem[i] = mmdb::getElementNo ( atom->element() );
+        if ((atom->element()[0]=='H') && (!atom->element()[1]))  {
+          strcpy ( HAtName[nHAtoms],atom->name_pdb(aname) );
+          nHAtoms++;
+        } else  {
+          strcpy ( NonHAtName[nNonHAtoms],atom->name_pdb(aname) );
+          nNonHAtoms++;
+        }
+        Chiral[i] = _makeChirInd ( atom->chirality() );
       }
-      Chiral[i] = _makeChirInd ( atom->chirality() );
     }
-  }
 
-  if (nHAtoms>0)  {
-    for (j=0;j<nHAtoms;j++)
-      Hconnect[j] = -1;
-    for (i=0;i<index[entryNo]->nBonds;i++)  {
-      bond = monomer->bond(i);
-      if (bond)  {
-        atom  = monomer->atom(bond->atom1());
-        atom2 = monomer->atom(bond->atom2());
-        if (atom && atom2)  {
-          j = _findName ( HAtName,atom->name_pdb(aname),nHAtoms );
-          if (j>=0)
-            Hconnect[j] = _findName ( NonHAtName,
-                                      atom2->name_pdb(aname),
-                                      nNonHAtoms );
-          else  {
-            j = _findName ( HAtName,atom2->name_pdb(aname),nHAtoms );
+    if (nHAtoms>0)  {
+      for (j=0;j<nHAtoms;j++)
+        Hconnect[j] = -1;
+      for (i=0;i<index[entryNo]->nBonds;i++)  {
+        bond = monomer->bond(i);
+        if (bond)  {
+          atom  = monomer->atom(bond->atom1());
+          atom2 = monomer->atom(bond->atom2());
+          if (atom && atom2)  {
+            j = _findName ( HAtName,atom->name_pdb(aname),nHAtoms );
             if (j>=0)
               Hconnect[j] = _findName ( NonHAtName,
-                                        atom->name_pdb(aname),
+                                        atom2->name_pdb(aname),
                                         nNonHAtoms );
+            else  {
+              j = _findName ( HAtName,atom2->name_pdb(aname),nHAtoms );
+              if (j>=0)
+                Hconnect[j] = _findName ( NonHAtName,
+                                          atom->name_pdb(aname),
+                                          nNonHAtoms );
+            }
           }
         }
       }
+      j = 0;
+      while ((j<nHAtoms) && (Hconnect[j]>=0)) j++;
+      if (j<nHAtoms)
+        rc = CCP4SRS_BrokenBonds;
     }
-    j = 0;
-    while ((j<nHAtoms) && (Hconnect[j]>=0)) j++;
-    if (j<nHAtoms)
-      rc = CCP4SRS_BrokenBonds;
-  }
-
-  delete monomer;
-
-  return rc;
-
-}
-
-
-int  CCP4SRSBase::getBonds ( cpstr   entryID,
-                             ivector nBonds, imatrix bondPair,
-                             int &   nAtoms, int     maxNAtoms,
-                             int     maxNBonds )  {
-PCGraph G;
-PCEdge  edge;
-int     entryNo,i, a1,a2,a;
-
-  for (i=0;i<maxNAtoms;i++)
-    nBonds[i] = 0;
-
-  nAtoms = 0;
-
-  entryNo = getEntryNo ( entryID );
-  if (entryNo<0)  return CCP4SRS_EntryNotFound;
-
-  nAtoms = index[entryNo]->nAtoms;
-  if (nAtoms<=0)  return CCP4SRS_Ok;
-
-  G = NULL;
-  i = getGraph ( entryNo,G,0 );
-  if (i!=CCP4SRS_Ok)  return i;
-  if (!G)             return CCP4SRS_ReadErrors;
-
-  for (i=1;i<=G->GetNofEdges();i++) {
-    edge = G->GetEdge(i);
-    if (edge)  {
-      a1 = edge->GetVertex1() - 1;
-      a2 = edge->GetVertex2() - 1;
-      if (a1>a2)  {
-        a = a1;  a1 = a2;  a2 = a;
-      }
-      if (nBonds[a1]<maxNBonds)  {
-        bondPair[a1][nBonds[a1]] = a2;
-        nBonds[a1]++;
-      }
-    }
-  }
-
-  delete G;
-
-  return CCP4SRS_Ok;
-
-}
-
-
-int  CCP4SRSBase::getHetInfo ( cpstr       entryID,
-                               pstr        Formula,
-                               pstr        Hname,
-                               pstr        Hsynonym,
-                               pstr        Hcharge,
-                               PAtomName & ClinkAtom,
-                               PElement  & ClinkEle,
-                               PAtomName & SlinkAtom,
-                               PElement  & SlinkEle,
-                               int       & nLeavingAtoms )  {
-PCCP4SRSMonomer monomer;
-PCCP4SRSAtom    atom;
-AtomName        aname;
-Element         elem;
-ivector         leavingAtom;
-ivector         bondedAtom;
-int             i,entryNo;
-
-  Formula [0] = char(0);
-  Hname   [0] = char(0);
-  Hsynonym[0] = char(0);
-  Hcharge [0] = char(0);
-  ClinkAtom   = NULL;
-  ClinkEle    = NULL;
-  SlinkAtom   = NULL;
-  SlinkEle    = NULL;
-  nLeavingAtoms = 0;
-
-  entryNo = getEntryNo ( entryID );
-  if (entryNo<0)  return CCP4SRS_EntryNotFound;
-
-  monomer = getMonomer ( entryNo,NULL );
-  if (!monomer)
-    return CCP4SRS_ReadErrors;
-
-  if (monomer->chem_formula()) strcpy ( Formula ,monomer->chem_formula() );
-  if (monomer->chem_formula()) strcpy ( Hsynonym,monomer->chem_formula() );
-  if (monomer->chem_type   ()) strcpy ( Hsynonym,monomer->chem_type   () );
-  if (monomer->chem_name   ()) strcpy ( Hname   ,monomer->chem_name   () );
-//  if (monomer->Charge)  strcpy ( Hcharge ,monomer->Charge  );
-
-  leavingAtom = NULL;
-  bondedAtom  = NULL;
-  monomer->getLeavingAtoms ( nLeavingAtoms,leavingAtom,bondedAtom );
-
-  if (nLeavingAtoms>0)  {
-    SlinkAtom = new AtomName[nLeavingAtoms];
-    SlinkEle  = new Element [nLeavingAtoms];
-    ClinkAtom = new AtomName[nLeavingAtoms];
-    ClinkEle  = new Element [nLeavingAtoms];
-    for (i=0;i<nLeavingAtoms;i++)  {
-      atom = monomer->atom ( leavingAtom[i] );
-      strcpy (SlinkAtom[i],atom->name_pdb(aname) );
-      strcpy (SlinkEle [i],atom->element_pdb(elem) );
-      if (bondedAtom[i]>=0)  {
-        atom = monomer->atom ( bondedAtom[i] );
-        strcpy(ClinkAtom[i],atom->name_pdb(aname) );
-        strcpy(ClinkEle [i],atom->element_pdb(elem) );
-      } else  {
-        ClinkAtom[i][0] = char(0);
-        ClinkEle [i][0] = char(0);
+
+    delete monomer;
+
+    return rc;
+
+  }
+
+
+  int  Base::getBonds ( mmdb::cpstr   entryID,
+                               mmdb::ivector nBonds,
+                               mmdb::imatrix bondPair,
+                               int         & nAtoms,
+                               int           maxNAtoms,
+                               int           maxNBonds )  {
+  mmdb::math::PGraph G;
+  mmdb::math::PEdge  edge;
+  int                entryNo,i, a1,a2,a;
+
+    for (i=0;i<maxNAtoms;i++)
+      nBonds[i] = 0;
+
+    nAtoms = 0;
+
+    entryNo = getEntryNo ( entryID );
+    if (entryNo<0)  return CCP4SRS_EntryNotFound;
+
+    nAtoms = index[entryNo]->nAtoms;
+    if (nAtoms<=0)  return CCP4SRS_Ok;
+
+    G = NULL;
+    i = getGraph ( entryNo,G,0 );
+    if (i!=CCP4SRS_Ok)  return i;
+    if (!G)             return CCP4SRS_ReadErrors;
+
+    for (i=1;i<=G->GetNofEdges();i++) {
+      edge = G->GetEdge(i);
+      if (edge)  {
+        a1 = edge->GetVertex1() - 1;
+        a2 = edge->GetVertex2() - 1;
+        if (a1>a2)  {
+          a = a1;  a1 = a2;  a2 = a;
+        }
+        if (nBonds[a1]<maxNBonds)  {
+          bondPair[a1][nBonds[a1]] = a2;
+          nBonds[a1]++;
+        }
       }
     }
+
+    delete G;
+
+    return CCP4SRS_Ok;
+
   }
 
-  FreeVectorMemory ( leavingAtom,0 );
-  FreeVectorMemory ( bondedAtom ,0 );
-  delete monomer;
 
-  return CCP4SRS_Ok;
+  int  Base::getHetInfo ( mmdb::cpstr       entryID,
+                                 mmdb::pstr        Formula,
+                                 mmdb::pstr        Hname,
+                                 mmdb::pstr        Hsynonym,
+                                 mmdb::pstr        Hcharge,
+                                 mmdb::PAtomName & ClinkAtom,
+                                 mmdb::PElement  & ClinkEle,
+                                 mmdb::PAtomName & SlinkAtom,
+                                 mmdb::PElement  & SlinkEle,
+                                 int             & nLeavingAtoms )  {
+  PMonomer       monomer;
+  PAtom          atom;
+  mmdb::AtomName aname;
+  mmdb::Element  elem;
+  mmdb::ivector  leavingAtom;
+  mmdb::ivector  bondedAtom;
+  int            i,entryNo;
+
+    Formula [0] = char(0);
+    Hname   [0] = char(0);
+    Hsynonym[0] = char(0);
+    Hcharge [0] = char(0);
+    ClinkAtom   = NULL;
+    ClinkEle    = NULL;
+    SlinkAtom   = NULL;
+    SlinkEle    = NULL;
+    nLeavingAtoms = 0;
+
+    entryNo = getEntryNo ( entryID );
+    if (entryNo<0)  return CCP4SRS_EntryNotFound;
+
+    monomer = getMonomer ( entryNo,NULL );
+    if (!monomer)
+      return CCP4SRS_ReadErrors;
+
+    if (monomer->chem_formula()) strcpy ( Formula ,monomer->chem_formula() );
+    if (monomer->chem_formula()) strcpy ( Hsynonym,monomer->chem_formula() );
+    if (monomer->chem_type   ()) strcpy ( Hsynonym,monomer->chem_type   () );
+    if (monomer->chem_name   ()) strcpy ( Hname   ,monomer->chem_name   () );
+  //  if (monomer->Charge)  strcpy ( Hcharge ,monomer->Charge  );
+
+    leavingAtom = NULL;
+    bondedAtom  = NULL;
+    monomer->getLeavingAtoms ( nLeavingAtoms,leavingAtom,bondedAtom );
+
+    if (nLeavingAtoms>0)  {
+      SlinkAtom = new mmdb::AtomName[nLeavingAtoms];
+      SlinkEle  = new mmdb::Element [nLeavingAtoms];
+      ClinkAtom = new mmdb::AtomName[nLeavingAtoms];
+      ClinkEle  = new mmdb::Element [nLeavingAtoms];
+      for (i=0;i<nLeavingAtoms;i++)  {
+        atom = monomer->atom ( leavingAtom[i] );
+        strcpy (SlinkAtom[i],atom->name_pdb(aname) );
+        strcpy (SlinkEle [i],atom->element_pdb(elem) );
+        if (bondedAtom[i]>=0)  {
+          atom = monomer->atom ( bondedAtom[i] );
+          strcpy(ClinkAtom[i],atom->name_pdb(aname) );
+          strcpy(ClinkEle [i],atom->element_pdb(elem) );
+        } else  {
+          ClinkAtom[i][0] = char(0);
+          ClinkEle [i][0] = char(0);
+        }
+      }
+    }
+
+    mmdb::FreeVectorMemory ( leavingAtom,0 );
+    mmdb::FreeVectorMemory ( bondedAtom ,0 );
+    delete monomer;
+
+    return CCP4SRS_Ok;
+
+  }
 
-}
+}  // namespace ccp4srs
